%lab15_ex_aac_switching
clear all; close all;

Nmany = 60;             % number of frames

Nl = 2048;              % long window length
Ns = 256;               % short window length
Ml = Nl/2;              % shift of long window
Ms = Ns/2;              % shift of short window

% Windows, matrices
nl =0:Nl-1;
ns =0:Ns-1;
wl = sin(pi*(nl+0.5)/Nl);                              % window long
ws = sin(pi*(ns+0.5)/Ns);                              % window short
wl2s = [ wl(1:Nl/2) ones(1,Nl/2-Ns/2) ws(Ns/2+1:Ns) ]; % long-to-short
ws2l = [ ws(1:Ns/2) ones(1,Nl/2-Ns/2) wl(Nl/2+1:Nl) ]; % short-to-long

figure;
subplot(221); stem(nl,wl);
subplot(222); stem(ns,ws);
subplot(223); stem(nl,wl2s);
subplot(224); stem(nl,ws2l); pause
subplot(111);

% MDCT matrices without windows
[nl,kl] = meshgrid(0:(Nl-1),0:(Nl/2-1));                %
[ns,ks] = meshgrid(0:(Ns-1),0:(Ns/2-1));                %
Cl = sqrt(2/Ml)*cos(pi/Ml*(kl+1/2).*(nl+1/2+Ml/2));     % long analysis
Dl = Cl';                                               % long synthesis
Cs = sqrt(2/Ms)*cos(pi/Ms*(ks+1/2).*(ns+1/2+Ms/2));     % short analysis
Ds = Cs';                                               % short synthesis

% Signal
Nx = Nl+Ml*(Nmany-1);            % number of samples
%x = randn(Nx,1); fs=44100;      % input
[ x, fs ] = audioread('Bach44100.wav');
size(x), pause
x = x(1:Nx,1); x=x.';
plot(x); pause
if(0) soundsc(x,fs); end

% Processing

type = [ 1 1 1 2 3 3 3 4 ];   % window switching sequence
%type = [ 1 1 1 1 1 1 1 1 ];  % 1=long, 2=long2short, 3=short, 4=short2long
type = repmat( type, 30);     % repeat 30 times

n1 = 1;          % initialization
y = zeros(1,Nx); % output
for k=1:Nmany
    what = type(k);
    if( what~=3)
      if(what==1) win=wl;   end  
      if(what==2) win=wl2s; end
      if(what==4) win=ws2l; end  
      M = Ml; N=Nl;
      C = Cl;
      D = Dl;
    else
      win = ws;  
      M = Ms; N=Ns;
      C = Cs;
      D = Ds;
    end  
        
    n1st = n1; nlast = n1+(N-1);   % from-to
    n = n1st : nlast;              % all indexes
    n1 = n1 + N/2;                 % store
    bx = x( n );                   % without window
    bx = bx.*win;                  % apply window
    BX = C*bx';                    % MDCT analysis
    
  % sub-band processing
  % BX(N/4+1:N/2,1) = zeros(N/4,1);
  
    by = D*BX;                     % IMDCT synthsis  
    y( n ) = y( n ) + win.*by';    % add with window
end    

n=1:Nx;
plot(n,x,'ro',n,y,'bx'); pause
soundsc(y,fs);

m=Ml+1:Nx-Ml;
max_abs_error = max(abs(y(m)-x(m))), pause
