function p = prototype(L)
%  generation of a simplified low-pass prototype filter for the MPEG audio filter bank

   a0=1; a(1)=-0.99998229; a(2)=0.99692250;
   a(4)=1/sqrt(2); a(6)=sqrt(1-a(2)^2); a(7)=-sqrt(1-a(1)^2);
   A=-( a0/2+a(1)+a(2)+a(4)+a(6)+a(7) );
   a(3)=A/2-sqrt(0.5-A^2/4); a(5)=-sqrt(1-a(3)^2);
   n = 0:L-1; p = a0*ones(1,L);
   for(k=1:7) p = p + 2*a(k)*cos(2*pi*k*n/L); end
   p = p/L; p(1)=0;
