function y = synthesisFB(sb, M)
% M-band synthesis filter bank in polyphase version

% Initialization
  load dewindow.dat; pd=dewindow'; L=length(pd);       % read MP2 prototype filter
  n=0:2*M-1;                                           % #
  for k=0:M-1                                          % # polyphase synthesis matrix
      B(k+1,1:2*M) = 2*cos((pi/M)*(k+0.5).*(n+M/2));   % # dimensions: M x 2M
  end                                                  % #
  MM=2*M; M2=2*M; M3=3*M; M4=4*M; Lp=L/MM; m = 0:Lp-1; % Lp = length of PP components

% Filter bank: synthesis
  y=[]; bv=zeros(1,2*L);              % initialization
  ns = length(sb(:,1));               % number of samples in each sub-band	
  for k = 1 : ns                      %
      v = B'*sb(k,1:M)';              % cosine demodulation
      bv = [ v' bv(1:2*L-M2) ];       % storing into buffer
      for n = 1 : M                   % polyphase filtration
          ys(n) = sum( bv(n+M4*m).*pd(n+M2*m) ) + sum( bv(n+M3+M4*m).*pd(n+M+M2*m) );
      end
      y = [ y ys ];
  end
